<template>
  <v-container>
    <v-card v-if="user">
      <v-card-title>
        Profil de {{user.Fullname}}
      </v-card-title>
      <v-card-text>
        <v-row>
          <v-col cols="12">
            <div v-if="isUserProfile">Actions</div>
          </v-col>
          <v-col cols="12" md="6">
            <ShoppingListDisplay v-if="isUserProfile" :userId="userId" />
          </v-col>
          <v-col cols="12" md="6">
            <RecipeList v-if="userRecipes" :recipes="userRecipes" listTitle="Recettes de l'utilisateur" />
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Prop, Watch } from "vue-property-decorator";
import User from "../../transport/User";
import Recipe from "../../transport/Recipe";
import UserService from "../../services/UserService";
import RecipeService from "../../services/RecipeService";
import ShoppingListDisplay from "./components/ShoppingListDisplay.vue";
import RecipeList from "../recipe/recipeComponents/RecipeList.vue";

@Component({
  components: {
    ShoppingListDisplay,
    RecipeList,
  },
})
export default class UserProfile extends Vue {
  @Prop({ type: String, required: true })
  userId;
  private user: User = null;
  private userRecipes: Recipe[] = null;
  private _userService: UserService = null;
  private _recipeService: RecipeService = null;

  get isUserProfile() {
    return this.connectedUser ? this.userId == this.connectedUser.Id : false;
  }
  @Watch("userId")
  onUserIdChange() {
    this.fetchUser();
  }
  get connectedUser(): User | null {
    return this.$store.state.connectedUser;
  }

  mounted() {
    this._userService = new UserService();
    this._recipeService = new RecipeService();
    this.fetchUser();
  }

  fetchUser() {
    if (!parseInt(this.userId)) this.$router.push({ name: "home" });
    this._userService.getUserById(this.userId).then(res => (this.user = res));
    this._recipeService.getRecipesForUser(this.userId).then(res => {
      this.userRecipes = res;
    });
  }
}
</script>

